#include "mrdebug.ch"
#include "inkey.ch"

/*Ŀ
   FunctionSysTitle() --> <cSysTitle>                                      
    PurposeReturn system title                                             
  */
FUNCTION SysTitle
RETURN ("MrDebug Version 1.10 Demo Program")

/*Ŀ
  Function Promotion                                                       
  Purpose  Otherwise, you'll be stuck at ensign for your whole career      
  */
FUNCTION Promotion

   STATIC nPos := 1, nLast := 0

   LOCAL cString := Space(80) +;
                    "Dark Black Software Limited proudly presents --- MrDebug 1.10 for CA-Clipper --- This evolutionary debugger can be yours in the UK by filling out the Order Form that can be printed out from the Demo Program Menu." + Space(10) +;
                    "An Alt-D keystroke will summon MrDebug. Press Alt for the Main menu." + Space(10) +;
                    "For a list of keys available press F1." + Space(10) +;
                    "Try Alt-F10 in each window which gives you a localised menu with options specific to that window." + Space(10) +;
                    "Want information on your program? then just press Shift-Alt-M for the Memory/Info window.  This also includes the Visual DGROUP chart to show you if your program could be prone to IE 650s & 667s." + Space(10) +;
                    "Having problems getting around your program code?  then try Shift-Alt-L which gives a list of functions in the current .PRG file, you can then type the name of the function (or part of it) and press enter to go to that place in the source file." + Space(10) +;
                    "Or go to a function call and press Ctrl-Alt-Plus, and if the function is located in the same .PRG, then you are placed on it!" + Space(10) +;
                    "Take a look at the profiler which will give you all you need to find the fastest (and slowest) parts of your program." + Space(10) +;
                    "Dark Black Software Limited can be contacted on the Internet at: Darren@darkblak.demon.co.uk"+ Space(10) +;
                    "In the UK, Dark Black Software can be contacted via their own BBS, the Dark Knight Returns on 0480 471465"+ Space(10) +;
                    "In the US, please contact Building Blocks Publishing, Inc on (201) 301-0822"+ Space(10) +;
                    "I want my..."+ Space(10) +"I want my..."+ Space(10) +"I want my..."+ Space(10) +"Visual DGROUP"


   LOCAL cDisplay, nSelect

   IF nLast == 0
      nLast := Seconds()
   ELSE
      IF Seconds() >= nLast + 0.14
         cDisplay := Left(SubStr(cString, nPos) + Left(cString, nPos), MaxCol(.T.) + 1)

         nSelect := WSelect(0)
         @ 1, MaxCol() - 9 SAY Time() COLOR "B/BG"
         @ MaxRow(), 0 SAY cDisplay COLOR "B/BG"
         WSelect(nSelect)

         IF ++nPos > Len(cString)
            nPos := 1
         ENDIF

         nLast := Seconds()
      ENDIF
   ENDIF

RETURN (NIL)

/*Ŀ
  Function AskYN()                                                         
  Purpose  Ask a question                                                  
  */
FUNCTION AskYN(cMessage)

   LOCAL nTop, nLeft, nKey

   nTop  := MaxRow(.T.) / 2 - 2
   nLeft := MaxCol(.T.) / 2 - (Len(cMessage) + 6) / 2

   WOpen(nTop, nLeft, nTop + 4, nLeft + Len(cMessage) + 5, .T., .F.)
   SetColor("GR+/G")
   WBox()

   SetColor("W+/G")
   @ 1, 2 SAY cMessage

   WVisible(.T.)

   nKey := __Inkey(0)

   WClose()

RETURN (nKey == Asc("Y") .OR. nKey == Asc("y"))

/*Ŀ
  Function __Inkey()                                                       
  Purpose  What else?                                                      
  */
FUNCTION __Inkey(nTime)

   LOCAL nKey := 0, nStart

   IF ValType(nTime) != "N"
      Promotion()
      nKey := Inkey()
   ELSE
      nStart := Seconds()

      DO WHILE nTime == 0 .OR. nStart + nTime > Seconds()
         Promotion()

         IF (nKey := Inkey()) != 0
            EXIT
         ENDIF
      ENDDO
   ENDIF

RETURN (nKey) AS INT

/*Ŀ
  Function Message()                                                       
  Purpose  Show a message                                                  
  */
FUNCTION Message(cMessage)

   LOCAL oWindow, nWidth := Len(cMessage) + 4

   IF nWidth > MaxCol(.T.) - 10
      nWidth := MaxCol(.T.) - 10
   ENDIF

   oWindow := Window():New(3, nWidth, "Notice")

   oWindow:cTitleColour := oWindow:cBorderColour := "GR+/G"

   SetColor("W+/G")
   Scroll()

   oWindow:Display()

   @ 1, 0 SAY PadC(cMessage, MaxCol() + 1)

RETURN (oWindow)
