#include "inkey.ch"
#include "mrdebug.ch"

/*Ŀ
  Function BreakCount()                                                    
  Purpose  Demo the Break count facility in MrDebug                        
  Date-Time14-07-94 12:41pm                                                
  CopyrightDark Black Software Ltd.             Date updated: 14-07-94     
  Author   Ian 'DrDebug' Day                    Time updated: 12:41:02pm   
  */
FUNCTION BreakCount()

   LOCAL oWindow, nLoop, nValue, nCount, nLots

   oWindow := Window():New(10, 40, "Break Count Demo"):Display()

   @ MaxRow(), 0 SAY PadC("Press ESC to quit", MaxCol() + 1)

   AltD()

   nLots := nValue := nCount := 0

   /* Ŀ
       To show an example of the break count facility,        
       try putting a BreakPoint (using the F9 to toggle it    
       on) on a line between the DO WHILE and the ENDDO.      
       Once you have done this you can either press the       
       + and - keys to increment and decrement the break      
       counter (the break count with be shown in brackets)    
       or you can select the Point->Break Count menu option   
       (or use hot key Shift-Alt-F9) to directly enter the    
       break count value.                                     
                                                              
       When you run the program, the break counter will be    
       decremented each time the line is run, and the         
       program will be stopped when the counter reaches zero. 
                                                              
       Whilst we are here, you may also want to try out the   
       Pass Point facility.  Try putting a Pass Point on      
       the 'nLots +=...' line (using Alt-F9 to toggle it      
       on/off),  when you next enter MrDebug and view this    
       line, you will notice that the counter for it has      
       increased to indicate how many times that line has     
       been executed since you set the passpoint.             
      */

   DO WHILE __Inkey() != K_ESC

      ++nCount
      nValue += nCount

      @ MaxRow() / 2 - 3, 0 SAY PadC(lTrim(Str(nCount)), MaxCol() + 1)
      @ MaxRow() / 2 - 1, 0 SAY PadC(lTrim(Str(nValue)), MaxCol() + 1)

      FOR nLoop := 1 TO 25

         nLots += (nCount * nLoop)

         @ MaxRow() / 2 + 1, 0 SAY PadC(lTrim(Str(nLots)), MaxCol() + 1)

      NEXT nLoop

   ENDDO

   oWindow:Close()

RETURN (NIL)
