#include "sixnsx2.ch"
#include "machsix.ch"
#include "mrdebug.ch"

REQUEST Sx_AutoOpen,   Sx_AutoShare,    Sx_DirtyArea,    Sx_FileOrder, Sx_IDtype,;
        Sx_IndexCount, Sx_IndexName,    Sx_IndexType,    Sx_IsDBT,     Sx_IsFLocked,;
        Sx_IsLocked,   Sx_IsMyRox,      Sx_IsReadOnly,   Sx_IsReIndex, Sx_IsRoxLock,;
        Sx_IsSem,      Sx_IsShared,     Sx_I_IndexName,  Sx_I_TagName, Sx_KeyCount,;
        Sx_KeyData,    Sx_KeyNo,        Sx_KeysIncluded, Sx_LockRetry, Sx_MemoExt,;
        Sx_SetDirty,   Sx_SetMemoBlock, Sx_SetScope,     Sx_SetScope,  Sx_SetTrigger,;
        Sx_SortOption, Sx_Step,         Sx_StrxCheck,    Sx_TableName, Sx_TableType,;
        Sx_TagCount,   Sx_TagNo,        Sx_TagUnique,    Sx_Version

REQUEST m6_IsFilter,   m6_IsOptimize,   m6_RecCount,     m6_SetTemp,   m6_Version

REQUEST SIXNSX, SIXCDX, SIXNTX

FIELD Info, aMemo, cKey, nKey, Num1, Num2, Num3, Num4

/*Ŀ
  Function BrowData()                                                      
  Purpose  Browse some data                                                
  */
FUNCTION BrowData()

   UseFiles()

   ALTD(6)                                                                     // Summon the workarea list

   CLOSE ALL

RETURN (NIL)

/*Ŀ
  Function UseFiles()                                                      
  Purpose  Create/Use some files                                           
  */
FUNCTION UseFiles()

   IF !FILE("DATA1.DBF")
      Data1Create()
   ELSE
      USE Data1 NEW VIA "DBFNTX" SHARED READONLY
      SET INDEX TO Data1.001, Data1.002, Data1.003, Data1.004
   ENDIF

   IF !File("Data2.dbf")
      data2Create(.T.)
   ELSE
      USE Data2 NEW VIA "SIXNSX" READONLY
      OrdSetFocus("Index1")
   ENDIF

   IF !File("Data3.dbf")
      data2Create(.F.)
   ELSE
      USE Data3 NEW VIA "SIXCDX" SHARED
      OrdSetFocus("Index1")
   ENDIF

RETURN (NIL)

/*Ŀ
  Function Data1Create()                                                   
  Purpose  Create DBFNTX file                                              
  */
FUNCTION Data1Create()

   LOCAL nI := 0

   LOCAL aDBF1 := {{"Num1", "N", 10, 0},;
                   {"Num2", "N", 10, 0},;
                   {"Num3", "N", 10, 0},;
                   {"Num4", "N", 10, 0}}

   RddSetDefault("DBFNTX")

   dbCreate("Data1", aDBF1)

   USE Data1 NEW VIA "DBFNTX" SHARED

   FOR nI := 1 TO 100
      dbAppend()

      data1->Num1 := nI
      data1->Num2 := 100 - nI * 10
      data1->Num3 := (100 - nI) * 0.175
      data1->Num4 := 100 - nI
   NEXT nI

   dbCommit()

   INDEX ON Data1->Num1 TO Data1.001
   INDEX ON Data1->Num2 TO Data1.002
   INDEX ON Data1->Num3 TO Data1.003
   INDEX ON Data1->Num4 TO Data1.004

   SET INDEX TO Data1.001, Data1.002, Data1.003, Data1.004

   dbGoTop()

RETURN (NIL)

/*Ŀ
  Function Data2Create()                                                   
  Purpose  Create DBFCDX file                                              
  */
FUNCTION Data2Create(lNSX)

   LOCAL nI := 0, cDriver := If(lNSX, "SIXNSX", "SIXCDX"), cFilename

   LOCAL aDBF2 := {{"Info",  "C", 50, 0},;
                   {"aMemo", "M", 10, 0},;
                   {"cKey",  "C",  5, 0},;
                   {"nKey",  "N",  5, 0}}

   LOCAL aInfo
   LOCAL aThings := {"Phone", "Dark", "Black", "Software", "Limited", "On", "01480", "403104"}

   IF lNSX
      aInfo := {"Press F1 for brief help on this screen",;
                "Each window has different options",;
                "",;
                "The last record is blank because it ",;
                "is an EOF record",;
                "",;
                "You can press RETURN on nearly",;
                "everything here",;
                "",;
                "Try it, press RETURN on the array",;
                "stored in the SMT file"}
   ELSE
      aInfo := {"MrDebug fully supports multiple",;
                "tag orders and multiple bags.",;
                "",;
                "OK, in plain English that means it",;
                "supports lots of index files with",;
                "each index file having lots of indexes",;
                "in it... ;-)"}
   ENDIF

   cFilename := If(lNSX, "Data2", "Data3")

   RddSetDefault(cDriver)

   dbCreate(cFilename, aDBF2)

   IF lNSX
      USE (cFilename) NEW VIA (cDriver) READONLY
   ELSE
      USE (cFilename) NEW VIA (cDriver) SHARED
   ENDIF

   FOR nI := 1 TO Len(aInfo)
      dbAppend()
      Field->Info  := aInfo[nI]

      IF nI == 2
         Field->aMemo := "Dark Black Software Limited"
      ELSEIF nI == 5
         Field->aMemo := aThings
      ELSE
         Field->aMemo := aInfo
      ENDIF

      Field->cKey  := Str(nI, 5)
      Field->nKey  := 20 - nI
   NEXT nLoop

   dbCommit()

   INDEX ON cKey TAG Index1
   INDEX ON nKey TAG Index2

   OrdSetFocus("Index1")
   dbGoTop()

RETURN (NIL)
