#include "mrdebug.ch"

/*Ŀ
  Function MakeGPF()                                                       
  Purpose  Crash the program with a GPF                                    
  */
FUNCTION MakeGPF()

   CauseGPF()

/*Ŀ
   You should see the Error/GPF window with familiar details   
   of the GPF including the name of the function that caused   
   the GPF.  The details come from the MAP file, which MrDebug 
   scans automatically.  So, in most cases you will not have   
   to write down numbers and plod through the MAP file.        
                                                               
   We say 'in most cases' because not all GPFs are             
   recoverable.  There are a variety of reasons like Stack     
   corruption or Virtual Memory corruption.  In cases where    
   the system is unstable after a GPF, you will most likely    
   get a second GPF.  This second GPF will be handled by the   
   original GPF handler.                                       
                                                               
   So, for the cases that the system is unstable we take the   
   following precautions:                                      
                                                               
        a) a .GPF file is create immedietly after the GPF has  
           occured.  This is very carefully written as to not  
           allocate memory which may be curtupt etc.           
                                                               
        b) The MrDebug GPF handler is then un-installed, to    
           prevent possible recursion due to currupted memory. 
                                                               
        c) An external MAP file scanner (MrGPF.EXE) can be     
           use to read the .GPF files and scan the MAP file    
           from the details saved to this file.  It will also  
           read screen dumps of GPFs from ALL of the Clipper   
           DOS extenders (Blinker, CauseWay & ExoSpace) and    
           scan the MAP file accordingly.                      
                                                               
                                                               
   If the GOF window is too small to see all of the            
   information, then just select it with Alt-8, and then press 
   Alt-M to move and size it.  Or you can use the mouse if you 
   really want to.                                             
                                                               
   A .GPF file was also create (To look at the GPF file just   
   use the VIEW command in the command window:                 
     'VIEW MRDDEMO.GPF'                                        
                                                               
   In the case of this particular 'forced' GPF, it is because  
   of an attempt to read from segment (selector) 0 (in DS with 
   this example) which is always invalid.  If you look at the  
   DS line of the registers you will notice that it is 0000    
   and that there are no other details for it.  Also at the    
   bottom then DS= line should say NULL.  If this pointed to a 
   valid segment, then it may give you some idea as to the     
   problem.  For example:                                      
                                                               
   In C you have a function that does something like           
                                                               
      strcat (cString1, cString2);                             
                                                               
   if cString1 already contains 'TEST: ' and cString2 points   
   to NULL, then the two lines would look something like:      
                                                               
   DS=NULL                                                     
   ES=...................TEST: [DI]..........................  
                                                               
   From this you may recognise that it could only be a limited 
   number of things that use this string.                      
                                                               
   The '.' characters represent 0's.  Except in the .GPF file  
   where any character below a space is turned to a '.' to     
   allow the file to be printed without any hassles.           
  */

RETURN (NIL)
