#Include "Box.ch"
#include "mrdebug.ch"
#include "inkey.ch"

EXTERNAL BLIMGRSTS, SWPRUNCMD, BLIVERNUM
EXTERNAL MethodName

STATIC cStatic

MEMVAR cPublic, cPrivate

/*Ŀ
  Function MAIN()                                                          
  Purpose  An even quicker demo program                                    
  */
FUNCTION MAIN()

   LOCAL cScreen := SAVESCREEN(0,0, MAXROW(), MAXCOL())

   LOCAL cLocal
   PUBLIC cPublic
   PRIVATE cPrivate

   cPublic  := "Alt-P toggle publics on or off"

   cStatic  := "Alt-S will toggle statics on or off"

   cPrivate := "Alt-V will toggle Private variables on or off"

   cLocal   := "Alt-L will toggle Local variable on or off"

   Screen()                                                                    // call a function

   Mainmenu()                                                                  // Play with an object

   RestScreen(0,0, MAXROW(), MAXCOL(), cScreen)

RETURN (NIL)

/*Ŀ
  Function StartStuff                                                      
  Purpose  Startup                                                         
  */
INIT FUNCTION StartStuff

   SetCursor(0)

   SET DATE BRITISH
   SET CENTURY OFF
   SET SCOREBOARD OFF
   SET CONFIRM ON
   SET BELL OFF

   Set(_SET_INSERT, .T.)

   WSetShadow(.T.)

RETURN (NIL)

/*Ŀ
   FunctionMainMenu() --> NIL                                              
    PurposeMain Menu                                                       
  */
STATIC FUNCTION MainMenu

   LOCAL oWindow, nChoice, lFinish := .F., cSetColor := SetColor("GR+/B,B/W,N,,W+/B"),;
         oTitle, oBrowse, nKey

   LOCAL aMenu := {"Print Order Form",;
                   "Look at DBFs",;
                   "Show a Tbrowse",;
                   "Disable an ALTD()",;
                   "Break Count",;
                   "Conditional Break Points",;
                   "Assertion Checking",;
                   "MrWindow",;
                   "Crash the Program",;
                   "Cause a GPF",;
                   "Quit"}

   LOCAL aBlocks := {{|| PrintOrder()   },;
                     {|| BrowData()     },;
                     {|| Browser(5, 10) },;
                     {|| DisAltd()      },;
                     {|| BreakCount()   },;
                     {|| CondBreak()    },;
                     {|| AssertTest()   },;
                     {|| ShowMrWindow() },;
                     {|| Crash()        },;
                     {|| MakeGPF()      },;
                     {|| lFinish := .T. }}

   WBoard(4, 0, MaxRow(.T.) - 2, MaxCol())

   oTitle := Title():New("Main Menu")
   oWindow := Window():New(8, 30,"Main Menu"):Display()

   SetColor("W+/B,B/W,N,,W+/B")
   @ 0, 1 TO MaxRow(), 1

   oBrowse := aBrowse():New(0, 2, MaxRow(), MaxCol(), aMenu)

   oBrowse:lSearchable := .T.

   DO WHILE !lFinish
      DispBegin()

      DO WHILE .T.
         oBrowse:ForceStable():DisplayArrows()
         DispEnd()

         nKey := __Inkey(0)

         DispBegin()

         DO CASE
            CASE nKey == K_ESC
               IF AskYN("Quit the MrDebug Demo?")
                  nChoice := 0
                  EXIT
               ENDIF

            CASE nKey == K_RETURN
               nChoice := oBrowse:nElement
               EXIT

            OTHERWISE
               oBrowse:Handler(nKey)

         ENDCASE
      ENDDO

      DispEnd()

      IF nChoice > 0
         Eval(aBlocks[nChoice])
      ELSE
         EXIT
      ENDIF
   ENDDO

   oWindow:CloseAll()
   oTitle:Close()
   SetColor(cSetColor)

RETURN (NIL)

/*Ŀ
   FunctionScreen() --> NIL                                                
    PurposeMain screen                                                     
  */
STATIC FUNCTION Screen

   DispBegin()

   SetColor("B/BG")
   @ 0, 0, 3, MaxCol() BOX B_SINGLE + " "
   @ MaxRow(), 0 CLEAR TO MaxRow(), MaxCol()

   @ 1, 2 SAY Date()
   @ 1, MaxCol() - 9 SAY Time()
   @ 1, MaxCol() / 2 - Len(SysTitle()) / 2 SAY SysTitle()

   @ 4, 0, MaxRow() - 1, MaxCol() BOX Replicate("", 9)

   DispEnd()

RETURN (NIL)

/*Ŀ
  Function DisAltd()                                                       
  Purpose  I left an ALTD() in that loop - ARGHHHHHHH!                     
  */
STATIC FUNCTION DisAltd()

   LOCAL nLoop := 0

   /*Ŀ
      How many time have you forgotten about an ALTD()  
      function within your code?                        
      MrDebug allows you to Disable an ALTD() function! 
     */

   FOR nLoop := 1 TO 10

      ALTD()     // Move the cursor to this line in the source code
                 // and press Shift-Alt-D. When you next run the
                 // program you won't have to keep pressing
                 // F5 until you are out of the loop.

   NEXT nLoop

RETURN (NIL)
