#include "mrdebug.ch"
#include "inkey.ch"

#define WINDOW_HANDLE      1
#define WINDOW_VERTICAL    2
#define WINDOW_HORROR      3
#define WINDOW_SHADOW      4

EXTERN ColorToN, NToColor

/*Ŀ
  Function ShowMrWindow                                                    
  Purpose  MrWindow demo                                                   
  */
FUNCTION ShowMrWindow

   LOCAL nLoop, anHandles, nTop, nLeft, nBottom, nRight, nWindow, lShadow,;
         nNumWindows

   AltD()

/* MrWindow is a FREE windowing system that was originally intended
   to replace the CA-Tools windowing system that wreaks havoc on the
   internals of Clipper.

   What we actually ended up with is a hybrid that can be used totally
   independantly.  ie: You don't need CA-Tools!

   As we developed MrWindow, we saw things that we blatently MISSING
   from the CA-Tools window module.  Such as:

         Manipulating windows that are not in focus

         Hiding windows and updating them in the background

         Creating hidden windows, so you can create them and
         display them all at once

   Anyway, just press F5 and have a look at a few windows... */

   anHandles := {}   //  Read this

   nNumWindows := 3

   FOR nLoop := 1 TO nNumWindows
      nTop    := FT_RAND1(MaxRow(.T.) / 2)
      nLeft   := FT_RAND1(MaxCol(.T.) / 2)
      nBottom := nTop + 5 + FT_RAND1(MaxRow(.T.) / 3)
      nRight  := nLeft + 10 + FT_RAND1(MaxCol(.T.) / 3)

      SetColor(Str(FT_RAND1(15), 2, 0) + "/" + Str(FT_RAND1(15), 2, 0))

      IF (lShadow := (FT_RAND1(10) > 6))
         WSetShadow(.T.)
      ELSE
         WSetShadow(.F.)
      ENDIF

      nWindow := WOpen(nTop, nLeft, nBottom, nRight, .T., .T.)

      IF nWindow == -1
         nNumWindows := nLoop - 1
         EXIT
      ENDIF

      aAdd(anHandles, {nWindow, FT_RAND1(10) > 5, FT_RAND1(10) > 5, lShadow})

      IF FT_RAND1(10) > 5
         WBox(0)
      ELSE
         Scroll()
      ENDIF

      SetPos(MaxRow() / 2 - 1, 0)
      ? "MrWindow comes FREE with MrDebug!!!"
   NEXT nLoop

   IF nNumWindows > 0
      DO WHILE Inkey() != K_ESC
         FOR nLoop := 1 TO nNumWindows
            Promotion()
            MoveWindow(anHandles[nLoop])
         NEXT nLoop
      ENDDO

      FOR nLoop := 1 TO nNumWindows
         WClose(anHandles[nLoop])
      NEXT nLoop
   ENDIF

   WSetShadow(.T.)

RETURN (NIL)

/*Ŀ
  Function MoveWindow()                                                    
  Purpose  Move a window                                                   
  */
STATIC FUNCTION MoveWindow(aWindow)

   LOCAL nWindow, nTop, nLeft

   nWindow := aWindow[WINDOW_HANDLE]
   nTop  := WRow(.F., nWindow)
   nLeft := WCol(.F., nWindow)

   IF aWindow[WINDOW_VERTICAL]
      nTop++
   ELSE
      nTop--
   ENDIF

   IF aWindow[WINDOW_HORROR]
      nLeft++
   ELSE
      nLeft--
   ENDIF

   WMove(nTop, nLeft, nWindow)

   IF aWindow[WINDOW_VERTICAL]
      IF WLastRow(.F., nWindow) >= MaxRow(.T.) - 2
         aWindow[WINDOW_VERTICAL] := .F.
      ENDIF
   ELSE
      IF WRow(.F., nWindow) <= 4
         aWindow[WINDOW_VERTICAL] := .T.
      ENDIF
   ENDIF

   IF aWindow[WINDOW_HORROR]
      IF WLastCol(.F., nWindow) >= MaxCol(.T.)
         aWindow[WINDOW_HORROR] := .F.
      ENDIF
   ELSE
      IF WCol(.F., nWindow) <= 0
         aWindow[WINDOW_HORROR] := .T.
      ENDIF
   ENDIF

RETURN (NIL)
